Subject: Re: [PATCH Linux] powerpc: add documentation for HWCAPs

From: Segher Boessenkool <[email-masked]>
Date: Tue, 24 May 2022 12:38:14 -0500

Hi!

On Tue, May 24, 2022 at 07:38:28PM +1000, Nicholas Piggin wrote:
> Thanks for all the comments and corrections. It should be nearing the
> point where it is useful now. Yes I do think it would be useful to align
> this more with OpenPOWER docs (and possibly eventually move it into the
> ABI, given that's the allocator of these numbers) but that's not
> done yet.

The auxiliary vector is a Linux/glibc thing, it should not be described
in more generic ABI documents.  It is fine where you have it now afaics.

> +Where software relies on a feature described by a HWCAP, it should check the
> +relevant HWCAP flag to verify that the feature is present before attempting to
> +make use of the feature.
> +
> +Features should not be probed through other means. When a feature is not
> +available, attempting to use it may result in unpredictable behaviour, and
> +may not be guaranteed to result in any reliable indication that the feature
> +is unavailable.

Traditionally VMX was tested for by simply executing an instruction and
catching SIGILL.  This is portable even.  This has worked fine for over
two decades, it's a bit weird to declare this a forbidden practice
now :-)

It certainly isn't recommended for more complex and/or newer things.

> +verstions.

(typo.  spellcheck maybe?)

Segher